// WTLCalc.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "resource.h"
#include <math.h>

CAppModule _Module;

class CCalcDialog : public CDialogImpl<CCalcDialog>,
                    public CUpdateUI<CCalcDialog>,
					public CWinDataExchange<CCalcDialog>
{
private:
	double m_number;

public:
	enum { IDD = IDD_CALC_DIALOG };

	BEGIN_MSG_MAP_EX(CCalcDialog)
		MSG_WM_INITDIALOG(OnInitDialog)
		COMMAND_HANDLER_EX(IDC_NUMBER, EN_CHANGE, OnNumberChanged)
		COMMAND_HANDLER_EX(IDC_EXP, BN_CLICKED, OnExp)
		COMMAND_HANDLER_EX(IDC_LN, BN_CLICKED, OnLn)
		COMMAND_HANDLER_EX(IDC_C, BN_CLICKED, OnC)
		COMMAND_HANDLER_EX(IDC_SQRT, BN_CLICKED, OnSqrt)
		COMMAND_HANDLER_EX(IDC_FACT, BN_CLICKED, OnFact)
		COMMAND_HANDLER_EX(IDC_PI, BN_CLICKED, OnPi)
		COMMAND_HANDLER_EX(IDCANCEL, BN_CLICKED, OnClose)
		//CHAIN_MSG_MAP(CSimpleDialog<IDD_CALC_DIALOG>)
	END_MSG_MAP()

	BEGIN_DDX_MAP(CCalcDialog)
		DDX_FLOAT(IDC_NUMBER, m_number)
	END_DDX_MAP()

	// 1.  ,   ,       UI
	//      BEGIN_UPDATE_UI_MAP  END_UPDATE_UI_MAP.
	BEGIN_UPDATE_UI_MAP(CCalcDialog)
		UPDATE_ELEMENT(IDC_EXP, UPDUI_CHILDWINDOW)
		UPDATE_ELEMENT(IDC_LN, UPDUI_CHILDWINDOW)
		UPDATE_ELEMENT(IDC_SQRT, UPDUI_CHILDWINDOW)
		UPDATE_ELEMENT(IDC_FACT, UPDUI_CHILDWINDOW)
	END_UPDATE_UI_MAP()

	void OnDataExchangeError(UINT, BOOL)
	{
	}

	void UpdateUI()
	{
		BOOL bValidNumber = DoDataExchange(TRUE);

		// 2.       UIEnable, UISetCheck  . .
		//           ,   
		//         WTL.
		if(bValidNumber)
		{
			UIEnable(IDC_EXP, TRUE);
			UIEnable(IDC_LN, m_number > 0);
			UIEnable(IDC_SQRT, m_number >= 0);
			UIEnable(IDC_FACT, m_number<=100 && m_number>0 && ((double)(unsigned long)m_number == m_number));
		}
		else
		{
			UIEnable(IDC_EXP, FALSE);
			UIEnable(IDC_LN, FALSE);
			UIEnable(IDC_SQRT, FALSE);
			UIEnable(IDC_FACT, FALSE);
		}

		// 3.       UIUpdateChildWindows.
		//           .
		UIUpdateChildWindows();
	}

	LRESULT OnInitDialog(HWND, LPARAM)
	{
		// 4.   ,    
		//      WTL,   UIAddChildWindowContainer.    
		//      .
		UIAddChildWindowContainer(m_hWnd);
		UpdateUI();

		HICON hIcon = ::LoadIcon(_Module.GetResourceInstance(), MAKEINTRESOURCE(IDI_CALC));
		SetIcon(hIcon);

		return 0;
	}

	LRESULT OnNumberChanged(UINT, int, HWND)
	{
		UpdateUI();
		return 0;
	}

	LRESULT OnExp(UINT, int, HWND)
	{
		DoDataExchange(TRUE);
		m_number = exp(m_number);
		DoDataExchange(FALSE);
		return 0;
	}

	LRESULT OnLn(UINT, int, HWND)
	{
		DoDataExchange(TRUE);
		m_number = log(m_number);
		DoDataExchange(FALSE);
		return 0;
	}

	LRESULT OnC(UINT, int, HWND)
	{
		m_number = 0.0;
		DoDataExchange(FALSE);
		return 0;
	}

	LRESULT OnSqrt(UINT, int, HWND)
	{
		DoDataExchange(TRUE);
		m_number = sqrt(m_number);
		DoDataExchange(FALSE);
		return 0;
	}

	LRESULT OnFact(UINT, int, HWND)
	{
		DoDataExchange(TRUE);

		double fact = 1.0;
		for(unsigned long n = 1; n != (unsigned long)m_number; n++)
		{
			fact *= n;
		}

		m_number = fact;
		DoDataExchange(FALSE);
		return 0;
	}

	LRESULT OnPi(UINT, int, HWND)
	{
		DoDataExchange(TRUE);
		m_number = 2*asin(1.0);
		DoDataExchange(FALSE);
		return 0;
	}

	LRESULT OnClose(UINT, int, HWND)
	{
		EndDialog(0);
		return 0;
	}

};

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
	_Module.Init(NULL, hInstance);

	CCalcDialog dlg;
	dlg.DoModal();

	_Module.Term();

	return 0;
}